using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    System.Data.SqlClient.SqlConnection sqlConn = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        string errStr = refreshOutgoingMessageList();
        if (errStr != "")
        {
            hideAndShowTextboxError(errStr);
            return;
        }
        else
            hideAndShowTextboxError("");

        errStr = refreshIncomingMessageList();
        if (errStr != "")
        {
            hideAndShowTextboxError(errStr);
            return;
        }
        else
            hideAndShowTextboxError("");
    }

    protected string refreshOutgoingMessageList()
    {
        //we keep the first 3 rows
        for (int i = tableOutMessages.Rows.Count - 1; i >= 3; --i)
            tableOutMessages.Rows.RemoveAt(i);

        string errText = createDatabaseConnection();
        if (sqlConn == null)
        {
            return errText;
        }
        else
            errText = "";

        try
        {
            System.Data.SqlClient.SqlCommand mySQLComm = sqlConn.CreateCommand();
            mySQLComm.CommandText = "select id,sender,receiver,msg,senttime,receivedtime," +
                "operator,msgtype,status from ozekimessageout;";

            System.Data.SqlClient.SqlDataReader dr = mySQLComm.ExecuteReader();
            if (dr != null)
            {
                while (dr.Read())
                {
                    TableRow tr = new TableRow();
                    TableCell tc = new TableCell();
                    tc.Text = (dr.IsDBNull(0)) ? ("&nbsp;") : (dr.GetInt32(0).ToString()); //id
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(1)) ? ("&nbsp;") : (dr.GetString(1)); //sender
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(2)) ? ("&nbsp;") : (dr.GetString(2)); //receiver
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(4)) ? ("&nbsp;") : (dr.GetString(4)); //senttime
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(5)) ? ("&nbsp;") : (dr.GetString(5)); //received time
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(6)) ? ("&nbsp;") : (dr.GetString(6)); //operator
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(8)) ? ("&nbsp;") : (dr.GetString(8)); //status
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(7)) ? ("&nbsp;") : (dr.GetString(7)); //msgtype
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(3)) ? ("&nbsp;") : (dr.GetString(3)); //msg
                    tr.Cells.Add(tc);
                    tableOutMessages.Rows.Add(tr);
                }
                dr.Close();
            }

            sqlConn.Close(); //we close the SQL connection
        }
        catch (Exception e)
        {
            errText = e.Message;
        }

        return errText;
    }

    protected string refreshIncomingMessageList()
    {
        //we keep the first 3 rows
        for (int i = tableInMessages.Rows.Count - 1; i >= 3; --i)
            tableInMessages.Rows.RemoveAt(i);

        string errText = createDatabaseConnection();
        if (sqlConn == null)
        {
            return errText;
        }
        else
            errText = "";

        try
        {
            System.Data.SqlClient.SqlCommand mySQLComm = sqlConn.CreateCommand();
            mySQLComm.CommandText = "select id,sender,receiver,msg,senttime,receivedtime," +
                "operator,msgtype from ozekimessagein;";

            System.Data.SqlClient.SqlDataReader dr = mySQLComm.ExecuteReader();
            if (dr != null)
            {
                while (dr.Read())
                {
                    TableRow tr = new TableRow();
                    TableCell tc = new TableCell();
                    tc.Text = (dr.IsDBNull(0)) ? ("&nbsp;") : (dr.GetInt32(0).ToString()); //id
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(1)) ? ("&nbsp;") : (dr.GetString(1)); //sender
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(2)) ? ("&nbsp;") : (dr.GetString(2)); //receiver
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(4)) ? ("&nbsp;") : (dr.GetString(4)); //senttime
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(5)) ? ("&nbsp;") : (dr.GetString(5)); //received time
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(6)) ? ("&nbsp;") : (dr.GetString(6)); //operator
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(7)) ? ("&nbsp;") : (dr.GetString(7)); //msgtype
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    tc.Text = (dr.IsDBNull(3)) ? ("&nbsp;") : (dr.GetString(3)); //msg
                    tr.Cells.Add(tc);
                    tableInMessages.Rows.Add(tr);
                }
                dr.Close();
            }

            sqlConn.Close(); //we close the SQL connection
        }
        catch (Exception e)
        {
            errText = e.Message;
        }

        return errText;
    }

    protected void buttonSendOnClick(object sender, EventArgs e)
    {
        //we check that recipient text box isn't empty
        if (textboxRecipient.Text == "")
        {
            hideAndShowTextboxError("Recipient(s) field mustn't be empty!");
            return;
        }

        hideAndShowTextboxError(
            putMessageToDatabase(textboxRecipient.Text, textboxMessage.Text));

        refreshIncomingMessageList();
        refreshOutgoingMessageList();
    }

    protected void hideAndShowTextboxError(string text)
    {
        if (text == "")
        {
            textboxError.Text = "";
            textboxError.Visible = false;
        }
        else
        {
            textboxError.Text = text;
            textboxError.Visible = true;
        }
    }

    protected string putMessageToDatabase(string receiver, string messageText)
    { 
        string errText = createDatabaseConnection();
        if (sqlConn == null)
        {
            return errText;
        }
        else
            errText = "";

        try
        {
            System.Data.SqlClient.SqlCommand mySQLComm = sqlConn.CreateCommand();
            mySQLComm.CommandText = "insert into ozekimessageout (msgtype,receiver,msg,status) " +
                "values ('SMS:TEXT','" + receiver + "','" + messageText + "','send');";
            if (mySQLComm.ExecuteNonQuery() == 0)
            {
                errText = "Insert was UNsuccessful!";
            }
            else
            {
                errText = "Insert was successful!";
            }

            sqlConn.Close(); //we close the SQL connection
        }
        catch (Exception e)
        {
            errText = e.Message;
        }

        return errText;
    }

    protected string createDatabaseConnection()
    {
        string errorText = "";

        if (sqlConn != null)
        {
            try
            {
                sqlConn.Open();
            }
            catch (Exception e)
            {
                errorText = e.Message;
            }
            return errorText;
        }

        //we create a database connection
        string SQLServerName = "(local)\\SQLExpress";
        string SQLServerDatabaseName = "ozekisms";
        string SQLServerUserName = "sqluser";
        string SQLServerPassword = "abc123";
        string connectionString =
            "Server=" + SQLServerName + ";Database=" + SQLServerDatabaseName + ";" + 
            "User Id=" + SQLServerUserName + ";Password=" + SQLServerPassword + ";";

        try
        {
            sqlConn = 
                new System.Data.SqlClient.SqlConnection(connectionString);
            sqlConn.Open();
        }
        catch (Exception exc)
        {
            errorText = exc.Message;
        }

        return errorText;
    }
}
